/*
 * MyDeployMBeanImpl.java
 *
 * Created on September 14, 2006, 11:59 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package mydeploymbean;

import java.util.HashMap;
import java.util.Map;
import java.util.Properties;
import javax.management.MBeanServerConnection;
import javax.management.ObjectName;
import javax.management.remote.JMXConnector;
import javax.management.remote.JMXConnectorFactory;
import javax.management.remote.JMXServiceURL;

/**
 *
 * @author bhavani
 */
public class MyDeploy implements MyDeployMBean {
    
    /** Creates a new instance of MyDeployMBeanImpl */
    public MyDeploy() {
    }
    
    class DeployTask implements Runnable {
        
        String archivePath = null;
        
        DeployTask(String archivePath) {
            this.archivePath = archivePath;
        }
        
        private MBeanServerConnection getMBeanServerConnection() {
            MBeanServerConnection mbsc = null;
            try {
                String adminUser = "admin";
                String adminPassword = "adminadmin";
                String jmxServiceURL = "service:jmx:rmi:///jndi/rmi://localhost:8686/jmxrmi";
                String[] credentials = new String[] { adminUser, adminPassword };
                Map env = new HashMap();
                env.put("jmx.remote.credentials", credentials);
                
                JMXServiceURL url = new JMXServiceURL(jmxServiceURL);
                JMXConnector jmxc = JMXConnectorFactory.connect(url, env);
                mbsc = jmxc.getMBeanServerConnection();
            } catch(Exception ex) {
                ex.printStackTrace();
            }
            return mbsc;
        }
        
        protected Properties getDeployActionProperties(String deployablefile, String ID){
            
            Properties p = new Properties();
            p.put("archiveName", deployablefile);
            p.put("name", ID);
            p.put("enable", "true");
            p.put("virtualservers", "server");
            p.put("force", "true");
            p.put("verify", "false");
            p.put("precompilejsp", "false");
            p.put("resourceAction","resDeployment");
            p.put("resourceTargetList", "server");
            return p;
        }
        
        public boolean doDeploy() {
            try {
                MBeanServerConnection mbsc = getMBeanServerConnection();
                //MBeanServerConnection mbsc = MBeanServerFactory.getMBeanServer();
                ObjectName mbean = new ObjectName("com.sun.appserv:type=applications,category=config");
                Object[] params = new Object[]{getDeployActionProperties(archivePath, "hello")};
                String[] signatures = new String[]{"java.util.Properties"};
                
                mbsc.invoke(mbean,"deploy", params,signatures);
                return true;
            } catch(Throwable t) {
                return false;
            }
        }
        
        
        public void run() {
            doDeploy();
        }
    }
    
    public boolean deploy(String archivePath) {
        try {
            System.err.println("Deploy called....");
            DeployTask dt = new DeployTask(archivePath);
            dt.run();
            /*
            Thread t = new Thread(dt);
            t.start();
            t.join();
             */
            return true;
        } catch(Exception ex) {
            ex.printStackTrace();
            return false;
        }
    }
    
}
